#/usr/bin/env python
"""
This simple example is used for the line-by-line tutorial
that comes with pygame. It is based on a 'popular' web banner.
Note there are comments here, but for the full explanation,
follow along in the tutorial.
"""
from __future__ import absolute_import


#Import Modules
import random
import os
import pygame
from pygame.locals import *

import jump.particle
import jump.units
import jump.util

if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'


def main():
    """this function is called when the program starts.
       it initializes everything it needs, then runs in
       a loop until the function returns."""
#Initialize Everything
    pygame.init()
    screen = pygame.display.set_mode((640, 480)) # , pygame.FULLSCREEN)
    pygame.display.set_caption('Jetpack Battle!')
    pygame.mouse.set_visible(0)

#Create The Backgound
    background = pygame.Surface(screen.get_size())
    background = background.convert()
    background.fill((200, 200, 255))

#Display The Background
    screen.blit(background, (0, 0))
    pygame.display.flip()

#Prepare Game Objects
    clock = pygame.time.Clock()
    leftplayer = jump.units.Player(isleft=True)
    rightplayer = jump.units.Player()
    playersprites = pygame.sprite.RenderPlain((rightplayer, leftplayer))
    particlesprites = pygame.sprite.RenderPlain()
    projectilesprites = pygame.sprite.RenderPlain()

#Main Loop
    while 1:
        clock.tick(60)

    #Handle Input Events
        for event in pygame.event.get():
            if event.type == QUIT:
                return
            elif event.type == KEYDOWN and event.key == K_ESCAPE:
                return

            # right player controls
            elif event.type == KEYDOWN and event.key == K_UP:
                rightplayer.jet()
            elif event.type == KEYUP and event.key == K_UP:
                rightplayer.unjet()
            elif event.type == KEYDOWN and event.key == K_KP_ENTER:
                projectilesprites.add(rightplayer.fire(leftplayer))

            # left player controls
            elif event.type == KEYDOWN and event.key == K_w:
                leftplayer.jet()
            elif event.type == KEYUP and event.key == K_w:
                leftplayer.unjet()
            elif event.type == KEYDOWN and event.key == K_SPACE:
                projectilesprites.add(leftplayer.fire(rightplayer))
        projectilesprites.update()
        playersprites.update()

        # draw the health bar
        lefthealth = pygame.Surface((leftplayer.hp * 2.5, 15))
        lefthealth = lefthealth.convert()
        lefthealth.fill((250 * (100 - leftplayer.hp) / 100, 250 * leftplayer.hp / 100, 0))
        righthealth = pygame.Surface((rightplayer.hp * 2.5, 15))
        righthealth = righthealth.convert()
        righthealth.fill((250 * (100 - rightplayer.hp) / 100, 250 * rightplayer.hp / 100, 0))

        # create particle effects
        particlesprites.update()
        for sprite in playersprites:
            jump.particle.jetparticles(sprite, particlesprites)

        # check if someone won
        if rightplayer.hp <= 0 or leftplayer.hp <= 0:
            if pygame.font:
                font = pygame.font.Font(None, 36)
                winner = "Left" if rightplayer.hp <= 0 else "Right"
                text = font.render(winner + " Player Wins!", 1, (10, 10, 10))
                textpos = text.get_rect(centerx=background.get_width() / 2.0,
                                        centery=background.get_height() / 2.0)
                background.blit(text, textpos)

            screen.blit(background, (0, 0))
            pygame.display.flip()
            pygame.time.delay(2000)
            return

    #Draw Everything
        screen.blit(background, (0, 0))
        screen.blit(lefthealth, (0, 0))
        screen.blit(righthealth, (380, 0))
        playersprites.draw(screen)
        particlesprites.draw(screen)
        projectilesprites.draw(screen)
        pygame.display.flip()

#Game Over


#this calls the 'main' function when this script is executed
if __name__ == '__main__': main()
